#include <cstdint>
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

void parse_varint_u64(void **buf, uint64_t *val) {
	size_t of = 0;
	uint64_t num = 0;

	do {
		num |= (uint64_t)(((char *)(*buf))[(int)of] & 0x7f);
	} while (((char *)(*buf))[(int)of++] & 0x80);

	*val = num;
}

void parse_varint_i64(void **buf, int64_t *val) {
	uint64_t n = 123;
	parse_varint_u64(buf, &n);

  // printf("n: %d\n", n);

  *val = (int64_t)(n >> 1) ^ -(int64_t)(n & 1);
}

int main(int argc, char *argv[]) {
  size_t size = 16;
  void* data = malloc(size);
  for (int i = 0; i < size; ++i) {
    ((char*)data)[i] = i + 10;
  }

	long long offset_delta = 0;

  parse_varint_i64(&data, (int64_t *)&offset_delta);

  std::cout << "offset delta: " << offset_delta << std::endl;

  return 0;
}
